;pro set_gpib_tplot_options;
;
;end

;  mav_sep_plot_spectra,presult=pp


pro set_tplot_options

store_data,'SEPx_SCIENCE',data = 'SEP?_SCIENCE_DATA SEP?_MEMDUMP_RANGE *NOTE',dlim={panel_size:5,yrange:[0,260]}
;store_data,'SEP_SCIENCE',data = 'SEP_SCIENCE_DATA SEP_SCIENCE_LABELS *NOTE',dlim={panel_size:5,yrange:[0,260]}
STORE_data,'SEPx_RATES',data='SEP?_HKP_NOPEAK_RATE SEP?_HKP_EVENT_CNTR SEP?_HKP_RATE_CNTR SEP?_SCIENCE_A',dlim={panel_size:2}
options,'SEP?_SCIENCE_DATA',spec=1,PANEL_SIZE=3,ZRANGE=[.8,500],ZLOG=1,yrange=[0,260.],ystyle=3
options,'SEP?_NOISE_DDATA',spec=1,PANEL_SIZE=1.5,ZRANGE=[.8,100],ZLOG=1,yrange=[0,60.],ystyle=2
options,'SEP?_NOISE_BASELINE SEP?_NOISE_SIGMA',colors='MBCGDR'
options,'SEP?_HKP_RATE_CNTR','linestyle';,1
;STORE_data,'sep_RATES',data='sep_HKP_NOPEAK_RATE sep_HKP_EVENT_CNTR sep_HKP_RATE_CNTR',dlim={panel_size:2}
options,'SEP?_HKP_NOPEAK_RATE',psym=-3 ;,colors='b'
options,'SEP?_HKP_?CMD_RATE',psym=-1,ystyle=3,psym_lim=300
ylim,'SEP?_RATES',.8,1e5,1
tplot_options,'no_interp',1
options,'SEP?_NOISE_BASELINE',constant=0.
options,'SEP?_SCIENCE_PSUM',panel_size=2
options,'SEP?_HKP_AMON_*',/ynozero
options,'GPIB_?',colors='rrggbb'


;colors='BBBBGGGGMMMMRRRRCCCCYYYY'
;store_data,'SEP2_MEMDUMP_RANGE',dlim=struct(constant=brr,labels=labels,labflag=2,psym=-1,linestyle=1,colors=colors)

sconst = findgen(26) * 10
slabs = strsplit('O T F OT FT FTO',' ',/extract)
slabs = ['   0-'+ slabs,'   1-'+slabs]
slabs = [replicate(' ',13),slabs,' ']
scolors = 'ddddddddddddd' + 'BGRMCYBGRMCY' +'d'
store_data,'SEPx_SCIENCE_LABELS',systime(1),transpose(sconst),dlim=struct(constant=sconst,labels=slabs,labpos=sconst,labflag=3)
options,'SEP?_SCIENCE_LABELS SEP?_SCIENCE_PSUM',colors =scolors
;options,'SEP_SCIENCE',constant = sconst
;ylim,'???_NOISE_BASELINE',-5,5
;ylim,'???_NOISE_SIGMA',0,6
options,'MISG_STATUS_ACT_FLAGS*',symsize=.4,psyms=4,psym_lim=400,colors='MBRRGMRBDMGRGRYY'

;store_data,'SEP_SCIENCE',data = 'SEP_SCIENCE_DATA SEP_SCIENCE_X *NOTE',dlim={panel_size:5,yrange:[0,260]}

case 1 of
1: tplot,'SEP?_HKP_VCMD_RATE SEP?_NOISE_BASELINE SEP?_NOISE_SIGMA SEP?_SCIENCE SEP?_RATES'
2: tplot,'SEP?_SCIENCE SEP?_SCIENCE_PSUM'
endcase
end


function get_samples,var,t,delta=delta
    if not keyword_set(delta) then delta=5.
    array = data_cut(var,t)
    for i=0,n_elements(t)-1 do begin
        array[i,*] = tsample(var,t[i]+[-delta,delta]/2. ,/average)
    endfor


return,array
end





pro mav_sep_record_baseline
tr = 0
    baseline = tsample('SEP?_NOISE_BASELINE',tr,/average,stdev=sig_baseline,/silent)
    sigma    = tsample('SEP?_NOISE_SIGMA',tr,/average,stdev=sig_sigma,/silent)
    res     = tsample('SEP?_NOISE_RES',average(tr))
u=-1

data = [[baseline],[sigma],[sig_baseline],[sig_sigma]]
sig  = [[baseline],[sigma],[sig_baseline],[sig_sigma]]
t = tr[0]
tstr = time_string(t)

file_open,'u','baselines.txt',unit=u
printf,u,tstr,data,res,format='(a20, 4("  ",6(" ",f7.4))," ",i2)'

free_lun,u

end





;pro mav_sep_crib


if  ~keyword_set(recbase) then begin
    recorder,recbase,port=2025,exec_proc='gseos_cmnblk_bhandler',destination='data/CMNBLK_YYYYMMDD_hhmmss.dat'
    exec,tplotbase,  exec_text=["tplot,verbose=0,wshow=0,trange=systime(1)+[-.9,.1] * 60 * 1",'timebar,systime(1)']
    exec,tekbase,  exec_text="tek_screen_shot,prefix='tek/',window=8"
    dprint,recbase,tekbase,tplotbase,/phelp
endif


;if size(/type,realtime) eq 0 then realtime=1

pathname=0
;pathname = 'maven/sep/prelaunch_tests/EM2/20120131_222340_preamp_flt_g1/gseos_common_msg.dat'
;pathname = 'maven/sep/prelaunch_tests/EM2/20120131_231216_preamp_flt_g2/gseos_common_msg.dat'
;pathname = 'maven/sep/prelaunch_tests/EM2/20120201_004351_preamp_flt_g3/gseos_common_msg.dat'
;pathname = 'maven/sep/prelaunch_tests/realtime/CMNBLK_20120211_015211_g4.dat'
;append_array,pathname,'maven/sep/prelaunch_tests/realtime/CMNBLK_20120212_050247_g4.dat'
;pathname = 'maven/sep/prelaunch_tests/realtime/CMNBLK_20120215_005308_g6.dat'
;pathname = 'maven/sep/prelaunch_tests/realtime/CMNBLK_20120215_014650_g7.dat'
;pathname = 'maven/sep/prelaunch_tests/EM2/20120215_023302_etu/gseos_common_msg.dat'
;pathname = 'maven/sep/prelaunch_tests/EM2/20120219_073140_exttp/gseos_common_msg.dat'
;pathname = 'maven/sep/prelaunch_tests/FM1/20120315_215726_/gseos_common_msg.dat'         ; actuator test (anomaly)
;pathname = 'maven/sep/prelaunch_tests/FM1/20120317_*/gseos_common_msg.dat'
;append_array,pathname, 'maven/sep/prelaunch_tests/FM1/20120316_012812_idle/gseos_common_msg.dat'   ; nothing
;append_array,pathname, 'maven/sep/prelaunch_tests/FM1/20120316_013917_fltspare2_attentest/gseos_common_msg.dat
;append_array,pathname, 'maven/sep/prelaunch_tests/FM1/20120316_015150_fltspare2_attentest/gseos_common_msg.dat'  ; actuator test
;append_array,pathname, 'maven/sep/prelaunch_tests/FM1/20120316_225529_fltspare2_attentest/gseos_common_msg.dat'
;append_array,pathname, 'maven/sep/prelaunch_tests/FM1/20120317_003542_fltspare1_attentest/gseos_common_msg.dat'  ; voltage test
;pathname = 'maven/sep/prelaunch_tests/bench2/20120416_182221_ATT_tests/gseos_common_msg.dat
;pathname = 'maven/sep/prelaunch_tests/bench1/2012*/gseos_common_msg.dat'   ; most recent
pathname = 'maven/sep/prelaunch_tests/bench1/20120405_190838_DAP007_DFE05_DFE07/gseos_common_msg.dat'  ;
append_array,pathname,'maven/sep/prelaunch_tests/bench1/20120405_225152_DAP007_DFE05_DFE07/gseos_common_msg.dat
pathname =0
append_array,pathname,'maven/sep/prelaunch_tests/bench1/20120427_164952_DAP008_D1_D4_radsample/gseos_common_msg.dat
;pathname = 'maven/sep/prelaunch_tests/bench2/20120418_171611_sens4_atttest/gseos_common_msg.dat
;pathname =0
; file = dialog_pickfile(/multiple)

if keyword_set(pathname) || keyword_set(file) then begin
if keyword_set(once) then stop

;once = 1
;stop
starttime = systime(1)
recorder,recbase,get_procbutton=proc_on,set_procbutton=0,get_filename=rtfile
mav_sep_misg_decom  ;  initialize variables
store_data,'*',/clear
mav_gse_cmnblk_file_read,realtime=realtime,pathname=pathname,file=file,last_version=1
recorder,recbase,set_procbutton=proc_on
mav_sep_misg_decom,/completed
dprint,'Done in ',systime(1)-starttime,' seconds'
endif

end



; .edit mav_sep_dap_calibrate
