;+
; Added instrument keyword, skt_only and a few extra strings that were
; missed,
; jmm, 30-jan-2008
;-
pro update_master, instrument = instrument, skt_only = skt_only

  If(keyword_set(instrument)) Then Begin
    masters = file_search('tha_*'+instrument+'*.skt')
  Endif Else masters = file_search('tha_*.skt')

  For j = 0, n_elements(masters)-1 Do Begin
    in_file = masters[j]
    new_sc = ['tha_', 'thb_', 'thc_', 'thd_', 'the_']
    new_name = ['THA>Themis A', 'THB>Themis B', 'THC>Themis C', 'THD>Themis D', 'THE>Themis E']
    new_probe_name = ['THA>Themis Probe A', 'THB>Themis Probe B', 'THC>Themis Probe C', $
                      'THD>Themis Probe D', 'THE>Themis Probe E']
    new_sc_id = ['{ "a" }', '{ "b" }', '{ "c" }', '{ "d" }', '{ "e" }']
    new_dash_sc1 = ['-A', '-B', '-C', '-D', '-E']
    new_scm_cal = ['SCM1', 'SCM2', 'SCM3', 'SCM4', 'SCM5']
    for i = 0, n_elements(new_sc)-1 do begin

      openr, inlun, in_file, /GET_LUN
      openw, lun, 'dummy.txt', /get_lun

      dtcor = 0

      while not EOF(inlun) do begin

        in_line = ''
        readf, inlun, in_line

        strreplace, in_line, 'tha_', strtrim(new_sc[i])
        strreplace, in_line, 'tha>Themis A', strtrim(new_name[i])
        strreplace, in_line, 'THA>Themis A', strtrim(new_name[i])
        strreplace, in_line, 'tha>THEMIS A', strtrim(new_name[i])
        strreplace, in_line, 'THA>THEMIS A', strtrim(new_name[i])
        strreplace, in_line, 'THA>Themis Probe A', strtrim(new_probe_name[i])
        strreplace, in_line, 'tha>Themis Probe A', strtrim(new_probe_name[i])
        strreplace, in_line, 'tha>THEMIS Probe A', strtrim(new_probe_name[i])
        strreplace, in_line, 'THA>THEMIS Probe A', strtrim(new_probe_name[i])
        strreplace, in_line, '-A', strtrim(new_dash_sc1[i])
        strreplace, in_line, '{ "a" }', strtrim(new_sc_id[i])
        strreplace, in_line, 'SCM1', strtrim(new_scm_cal[i])

        if strmatch(in_line, '*_dtcor*') then dtcor = 1
        if dtcor eq 1 then strreplace, in_line, 'CDF_REAL8', 'CDF_REAL4'
        if strmatch(in_line, '*VALIDMAX*') then dtcor = 0

        printf, lun, in_line
      endwhile
      free_lun, lun
      free_lun, inlun
      out_file = in_file
      strreplace, out_file, 'tha_', strtrim(new_sc[i])
      copyit = '/bin/mv dummy.txt '+out_file
      spawn, copyit
;if create the cdf file, remove old ones first
      If(not keyword_set(skt_only)) Then Begin
        cdff = file_basename(out_file, '.skt')+'.cdf'
        If(is_string(file_search(cdff))) Then Begin
          spawn, '/bin/rm '+cdff
        Endif
        spawn, '/usr/local/pkg/cdf-3.1/bin/skeletoncdf '+out_file
      Endif
    endfor                      ; i
  endfor                        ; j


end





