; This crib sheet is demo of cleaning EFI burst data with LASP codes.
; This crib sheet is intended to be used in a copy-and-paste fashion.
;
; History:
;     2010-04-08: Created by Jianbao Tao (JBT), CU/LASP.
;

;===============================================================================
; Case 1. Tail region data.
   sc = 'd'
   thx0 = 'th' + sc
   thx = thx0 + '_'
   date = '2008-03-15'

   timespan, date
   thm_load_state, probe = sc, /get_support

   ; Clean EFI burst data.
   thm_efi_clean_efp, probe = sc
   thm_efi_clean_efw, probe = sc

   ; Check EFP data.
   tvar = thx + 'efp'
   btrange = thm_jbt_get_btrange(tvar, nb = nb, tind = tind)
   ; thx + 'efp: data BEFORE cleaning
   ; thx + 'efp_clean_dsl': data AFTER cleaning
   tlist = thx + ['efp', 'efp_clean_dsl']
;   .r
   for ib = 0, nb -1 do begin
      tr = btrange[*, ib]
      tplot, tlist, trange = tr
      print, ''
      print, '>>>>>>>>>>>> Type .con to continue... '
      print, ''
      stop
      if ib eq nb -1 then begin
         print, ''
         print, '      Check is over.'
         print, ''
      endif
   endfor
   end

   ; Check EFW data.
   tvar = thx + 'efw'
   btrange = thm_jbt_get_btrange(tvar, nb = nb, tind = tind)
   ; thx + 'efw: data BEFORE cleaning
   ; thx + 'efw_clean_dsl': data AFTER cleaning
   tlist = thx + ['efw', 'efw_clean_dsl']
;   .r
   for ib = 0, nb -1 do begin
      tr = btrange[*, ib]
      tplot, tlist, trange = tr
      print, ''
      print, '>>>>>>>>>>>> Type .con to continue... '
      print, ''
      stop
      if ib eq nb -1 then begin
         print, ''
         print, '      Check is over.'
         print, ''
      endif
   endfor
   end

;===============================================================================
; Case 2. Subsolar region data.
   sc = 'd'
   thx0 = 'th' + sc
   thx = thx0 + '_'
   date = '2008-08-16'

   timespan, date
   thm_load_state, probe = sc, /get_support

   ; Clean EFI burst data.
   thm_efi_clean_efp, probe = sc, /subsolar
   thm_efi_clean_efw, probe = sc

   ; Check EFP data.
   tvar = thx + 'efp'
   btrange = thm_jbt_get_btrange(tvar, nb = nb, tind = tind)
   ; thx + 'efp: data BEFORE cleaning
   ; thx + 'efp_clean_dsl': data AFTER cleaning
   tlist = thx + ['efp', 'efp_clean_dsl']
;   .r
   for ib = 0, nb -1 do begin
      tr = btrange[*, ib]
      tplot, tlist, trange = tr
      print, ''
      print, '>>>>>>>>>>>> Type .con to continue... '
      print, ''
      stop
      if ib eq nb -1 then begin
         print, ''
         print, '      Check is over.'
         print, ''
      endif
   endfor
   end

   ; Check EFW data.
   tvar = thx + 'efw'
   btrange = thm_jbt_get_btrange(tvar, nb = nb, tind = tind)
   ; thx + 'efw: data BEFORE cleaning
   ; thx + 'efw_clean_dsl': data AFTER cleaning
   tlist = thx + ['efw', 'efw_clean_dsl']
;   .r
   for ib = 0, nb -1 do begin
      tr = btrange[*, ib]
      tplot, tlist, trange = tr
      print, ''
      print, '>>>>>>>>>>>> Type .con to continue... '
      print, ''
      stop
      if ib eq nb -1 then begin
         print, ''
         print, '      Check is over.'
         print, ''
      endif
   endfor
   end

