;+
; NAME:
;     VH (PROCEDURE)
;
; PURPOSE:
;     To make a shortcut to the IDL procedure DOC_LIBRARY
;
; CALLING SEQUENCE:
;     vh, pro_name
;
; ARUGMENTS:
;     pro_name: (INPUT, REQUIRED) The name of an IDL routine.
;
; KEYWORDS:
;     None.
;
; EXAMPLES:
;     vh, 'trange_clip'
;
; HISTORY:
;     2008-05-23: Created by JBT, CU/LASP.
;     2010-04-07: Modified to be ready for public use. JBT, CU/LASP.
;
;-

pro vh, pro_name
   if n_elements(pro_name) eq 0 then begin
      print, 'VH: No name of an IDL routine is provided. Exiting...'
      return
   endif

   tmp = size(pro_name, /type)
   if tmp ne 7 then begin
      print, 'VH: The argument PRO_NAME must be a string of the name of an '+$
         'IDL routine. Exiting...'
      return
   endif
   doc_library, pro_name[0]
end
