;+
;thm_ui_draw_object method: getPanelLayouts
;
;This routine aggregates the layout structures from
;the panel objects into one array.  This makes certain
;layout operations simpler
;
;INPUTS:
;  panels: An array of thm_ui_panels
;  
;OUTPUTS:
;  an array of layout structures returned by the thm_ui_panel->getLayoutStructure() method
; 
;$LastChangedBy: pcruce $
;$LastChangedDate: 2010-08-25 18:05:01 -0700 (Wed, 25 Aug 2010) $
;$LastChangedRevision: 7774 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/thm_ui_new/display/draw_object/thm_ui_draw_object__getpanellayouts.pro $
;-
function thm_ui_draw_object::getPanelLayouts,panels

  compile_opt idl2
  
  layout_struct = panels[0]->getLayoutStructure()
  
  layout_array = replicate(layout_struct,n_elements(panels))
  
  for i = 0,n_elements(panels)-1 do begin
    layout_array[i] = panels[i]->getLayoutStructure()
  endfor

  return,layout_array

end