;+
;
;thm_ui_draw_object method: getTextModel
;
;returns a text model by digesting the settings on a thm_ui_text object.
;This is basically just a wrapper for getTextObject
;text: a thm_ui_text object
;loc: the normalized location of the text, relative to the view [xpos,ypos,zpos]
;offsetDirFlag: 0=centered,1=abovelocation,-1=belowlocation
;justify, -1 = left, 1=right, 0 = middle
;
;Output:
;  an IDLgrModel containing an IDLgrText object
;
;$LastChangedBy: pcruce $
;$LastChangedDate: 2010-08-25 18:05:01 -0700 (Wed, 25 Aug 2010) $
;$LastChangedRevision: 7774 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/thm_ui_new/display/draw_object/thm_ui_draw_object__gettextmodel.pro $
;-

function thm_ui_draw_object::getTextModel,text,loc,offsetDirFlag,orientation,justify=justify,enable_formatting=enable_formatting

  compile_opt idl2
  
  grText = self->getTextObject(text,loc,offsetDirFlag,orientation,justify=justify,enable_formatting=enable_formatting)
  
  model = obj_new('IDLgrModel')
  
  model->add,grText
  
  return,model
  
end