;+
;
;thm_ui_draw_object method: setLegendHide
;
;Because the static components of the legend are still somewhat
;dynamic(Because they can be manipulated between updates), 
;This routine is needed to manipulate them separately
;From the lists in self.staticViews & self.dynamicViews
;Inputs:
;  dynamic(boolean keyword):, set to hide dynamic component of the legend
;  hide:(boolean): set to the hide value you want to use
; 
;$LastChangedBy: pcruce $
;$LastChangedDate: 2010-08-25 18:05:01 -0700 (Wed, 25 Aug 2010) $
;$LastChangedRevision: 7774 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/thm_ui_new/display/draw_object/thm_ui_draw_object__setlegendhide.pro $
;-

pro thm_ui_draw_object::setLegendHide,dynamic=dynamic,hide=hide

 if n_elements(hide) gt 0 then begin
   if keyword_set(hide) then begin
     hideValueDynamic = 1
     hideValueStatic = 1
   endif else begin
     hideValueDynamic = 0
     hideValueStatic = 0
   endelse 
 endif else if self.legendOn eq 1 || self.legendOn eq 2 then begin
   if keyword_set(dynamic) then begin
     hideValueStatic = 0
     hideValueDynamic = 0
   endif else begin
     hideValueDynamic = 1
     hideValueStatic = 1
   endelse
 endif else begin
   hideValueDynamic = 1
   hideValueStatic = 1
 endelse

 if ptr_valid(self.panelInfo) then begin
  
   for i = 0,n_elements(*self.panelInfo)-1 do begin
    
     panel = (*self.panelInfo)[i]
      
     if ~obj_valid(panel.legendModel) then continue
    
  ;   print,i,hidevaluestatic,hidevaluedynamic
    
     panel.legendModel->setProperty,hide=hideValueStatic
     panel.legendAnnoModel->setProperty,hide=hideValueDynamic
    
     self->setVarHide,panel,hideValueDynamic
      
   endfor
    
  endif

end