;+
;
;thm_ui_draw_object method: setVarHide
;
;This routine sets the hide value for variables on a panel with
;a particular index.  It is mainly here for organization and to prevent duplication
;
;Inputs:
;  hidevalue(boolean): The value that the hide flag will be set to.
;
;$LastChangedBy: pcruce $
;$LastChangedDate: 2010-08-25 18:05:01 -0700 (Wed, 25 Aug 2010) $
;$LastChangedRevision: 7774 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/thm_ui_new/display/draw_object/thm_ui_draw_object__setvarhide.pro $
;-

pro thm_ui_draw_object::setVarHide,panel,hideValue

  if ptr_valid(panel.varInfo) then begin
  
     for j = 0,n_elements(*panel.varInfo)-1 do begin
        var = (*panel.varInfo)[j]
        
        if obj_valid(var.textObj) then begin
          var.textObj->setProperty,hide=hideValue
        endif
     endfor
    
   endif

end