;+
;
;  Name: thm_ui_scroll_view
;  
;  Purpose: Moves the area viewport of the draw area if the entire viewing area is not displayed
;  
;  Inputs: draw_widget: The draw widget for the visible drawing area
;          dir: 0=down, 1=up 
;
;
;$LastChangedBy: pcruce $
;$LastChangedDate: 2012-02-22 15:46:50 -0800 (Wed, 22 Feb 2012) $
;$LastChangedRevision: 9822 $
;$URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/thm_ui_new/utilities/thm_ui_main_funcs/thm_ui_scroll_view.pro $
;-
pro thm_ui_scroll_view,draw_widget,dir

  widget_control,draw_widget,get_draw_view=draw_view_pos

  geom=widget_info(draw_widget,/geometry)
  
  shift_factor = .3 ;what fraction of the visible area should be shifted for each click
  
  if dir eq 0 then begin
    draw_view_pos[1] = (draw_view_pos[1]-geom.scr_ysize*shift_factor)>0
  endif else if dir eq 1 then begin
    draw_view_pos[1] = (draw_view_pos[1]+geom.scr_ysize*shift_factor)
  endif
  
  widget_control,draw_widget,set_draw_view=draw_view_pos
  
  ;print,'View Pos',draw_view_pos
  ;print,'Xsize',geom.xsize
  ;print,'scrXsize',geom.scr_xsize
  ;print,'drawXsize',geom.draw_xsize
  
  ;print,'Ysize',geom.ysize
  ;print,'scrYsize',geom.scr_ysize
  ;print,'drawYsize',geom.draw_ysize

end